#!/usr/bin/perl

	if ($ARGV[0] ne 0 && $ARGV[1] != 0  && $ARGV[2] != 0  && $ARGV[3] != 0 ){
		&loop();
	} else {
		print (" -----  Usage  ------\n");
		print (" ofdm_analysis.pl <file1> <fspl(Hz)> <fc(Hz)> <bw(Hz)>\n");
		print (" Specify fspl in Hz.\n");
		print ("         center freq in Hz.\n");
		print ("         band width in Hz.\n");
	}

sub loop{
	$infile1 = $ARGV[0];
	$fspl = $ARGV[1];
	$fc = $ARGV[2];
	$bw = $ARGV[3];

	open (IN1,"$infile1") || die "Opening $infile1 failed."; 
	print ("New IN File $infile1 Opened!!\n");

	@list1 = <IN1>;
	$nline = $#list1;

	$pointfrq = $fspl / $nline;  # Freq / 1point
	$bwpoint = $bw / $pointfrq;
	$fcpoint = $fc / $pointfrq;
	$fstart = $fcpoint - ($bwpoint / 2);
	$fstop = $fcpoint + ($bwpoint / 2);

	$sum = 0;
	for ($i=0; $i<=$#list1; $i++){
		($d,$f) = split(/\s+/,$list1[$i]);

		if ($i >= $fstart && $i < $fstop ){
			$sum += $f;
#			printf ("%d %f %f\n",$i,$f, $sum);
		}
	}
	printf ("results:file=[%s] sum=%f n=%d ave=%f \n",$infile1,$sum,$bwpoint,($sum/$bwpoint));

close (IN1);
}


